<?php

/*
Copyright (C) 2008  Simon Emery

This file is part of OIOpublisher Direct.
*/

if(!defined('oiopub')) die();

//reporting
class oiopub_reports {

	var $show_emails = 1;
	
	//constructor
	function oiopub_reports() {
		global $oiopub_set;
		//demo mode?
		if($oiopub_set->demo) {
			$this->show_emails = 0;
		}
	}

	//export purchase data (html)
	function html_purchases($args=array()) {
		global $oiopub_db, $oiopub_set;
		//clear
		$array = array();
		$where = "1=1";
		$totals_price = 0;
		//get args
		$currency = oiopub_clean($args['currency']);
		$date_from = oiopub_clean($args['from']);
		$date_to = oiopub_clean($args['to']);
		$status = intval($args['status']);
		//where clause
		if($status == 1) {
			$where .= " AND item_status < '2' AND payment_status='1'";
		} elseif($status == 2) {
			$where .= " AND item_status < '3' AND payment_status!='1'";
		} else {
			$where .= " AND item_status < '3'";
		}
		if(!empty($date_from)) {
			$where .= " AND payment_time >= '" . strtotime($date_from) . "'";
		}
		if(!empty($date_to)) {
			$where .= " AND payment_time <= '" . strtotime($date_to) . "'";
		}
		if(!empty($currency)) {
			$where .= " AND payment_currency='" . $currency . "'";
		}
		//headers
		$headers = "<tr><th><b>Client</b></th><th><b>Purchase</b></th><th><b>Date</b></th><th><b>Amount</b></th><th><b>Currency</b></th><th><b>Processor</b></th><th><b>Subscription</b></th><th><b>Status</b></th></tr>\n";
		//process sql
		$sql = $oiopub_db->GetAll("SELECT * FROM " . $oiopub_set->dbtable_purchases . " WHERE " . $where . " ORDER BY payment_time");
		if(!empty($sql)) {
			foreach($sql as $s) {
				$pdata = oiopub_adtype_info($s);
				$date = date("Y-m-d", $s->payment_time);
				if($s->item_subscription == 1) {
					$subscription = "Yes";
				} else {
					$subscription = "No";
				}
				$array[$s->payment_time] = "<tr><td>" . $s->adv_name . ($this->show_emails == 1 ? "<br />" . $s->adv_email : "") . "</td><td>" . $pdata['type'] . ($s->item_duration > 0 ? "<br /><i>" . number_format($s->item_duration, 0) . " " . $s->item_model . "</i>" : "") . "</td><td>" . $date. "</td><td>" . $s->payment_amount . "</td><td>" . strtoupper($s->payment_currency) . "</td><td>" . strtolower($s->payment_processor) . "</td><td>" . $subscription . "</td><td>" . $pdata['istatus'] . ", " . $pdata['pstatus'] . "</td></tr>\n";
				$totals_price += $s->payment_amount;
			}
		}
		if($status != 2) {
			//clear
			$where = "";
			//where clause
			if(!empty($date_from)) {
				$where .= " AND h.time >= '" . strtotime($date_from) . "'";
			}
			if(!empty($date_to)) {
				$where .= " AND h.time <= '" . strtotime($date_to) . "'";
			}
			if(!empty($currency)) {
				$where .= " AND h.currency='" . $currency . "'";
			}
			//process sql
			$sql = $oiopub_db->GetAll("SELECT p.*, h.* FROM " . $oiopub_set->dbtable_purchases_history . " h, " . $oiopub_set->dbtable_purchases . " p WHERE h.item=p.item_id " . $where . " ORDER BY h.time");
			if(!empty($sql)) {
				foreach($sql as $s) {
					$pdata = oiopub_adtype_info($s);
					$date = date("Y-m-d", $s->time);
					if($s->subscription == 1) {
						$subscription = "Yes";
					} else {
						$subscription = "No";
					}
					$array[$s->time] = "<tr><td>" . $s->adv_name . "</td><td>" . ($this->show_emails == 1 ? $s->adv_email : "*****") . "</td><td>" . $pdata['type'] . "</td><td>" . $date . "</td><td>" . $s->amount . "</td><td>" . strtoupper($s->currency) . "</td><td>" . strtolower($s->processor) . "</td><td>" . $subscription . "</td><td>Expired, Paid</td></tr>";
					$totals_price += $s->amount;
				}
			}
		}
		$output  = "<table width='100%' border='0' cellspacing='0' cellpadding='6' class='widefat'>\n";
		$output .= "<thead>\n";
		$output .= $headers;
		$output .= "</thead>\n";
		$output .= "<tbody>\n";
		if(!empty($array)) {
			ksort($array);
			foreach($array as $a) {
				$output .= $a;
			}
			$output .= "<tr><td><b>Totals:</b></td><td>-</td><td>-</td><td><b>" . number_format($totals_price, 2)  . "</b></td><td>-</td><td>-</td><td>-</td><td>-</td><td>-</td></tr>\n";
		} else {
			$output .= "<tr><td colspan='9' align='center' style='padding-top:15px;'><i>no data currently available</i></td></tr>\n";
		}
		$output .= "</tbody>\n";
		$output .= "</table>\n";
		//display
		return $output;
	}
	
	//export purchase data (excel)
	function excel_purchases($args=array()) {
		global $oiopub_db, $oiopub_set;
		//clear
		$array = array();
		$where = "1=1";
		$totals_price = 0;
		//filename
		$filename = "oiopub-purchases-" . date('Ymd') . ".xls";
		//get args
		$currency = oiopub_clean($args['currency']);
		$date_from = oiopub_clean($args['from']);
		$date_to = oiopub_clean($args['to']);
		$status = intval($args['status']);
		//where clause
		if($status == 1) {
			$where .= " AND item_status < '2' AND payment_status='1'";
		} elseif($status == 2) {
			$where .= " AND item_status < '3' AND payment_status!='1'";
		} else {
			$where .= " AND item_status < '3'";
		}
		if(!empty($date_from)) {
			$where .= " AND payment_time >= '" . strtotime($date_from) . "'";
		}
		if(!empty($date_to)) {
			$where .= " AND payment_time <= '" . strtotime($date_to) . "'";
		}
		if(!empty($currency)) {
			$where .= " AND payment_currency='" . $currency . "'";
		}
		//headers
		$output = "Name\tEmail\tPurchase\tFor\tDate\tAmount\tCurrency\tProcessor\tSubscription\tStatus\n";
		//process sql
		$sql = $oiopub_db->GetAll("SELECT * FROM " . $oiopub_set->dbtable_purchases . " WHERE " . $where . " ORDER BY payment_time");
		if(!empty($sql)) {
			foreach($sql as $s) {
				$pdata = oiopub_adtype_info($s);
				$date = date("Y-m-d", $s->payment_time);
				if($s->item_subscription == 1) {
					$subscription = "Yes";
				} else {
					$subscription = "No";
				}
				$array[$s->payment_time] = $s->adv_name . "\t" . ($this->show_emails == 1 ? $s->adv_email : "*****") . "\t" . $pdata['type'] . "\t" . $s->item_duration . " " . $s->item_model . "\t" . $date . "\t" . $s->payment_amount . "\t" . strtoupper($s->payment_currency) . "\t" . strtolower($s->payment_processor) . "\t" . $subscription . "\t" . $pdata['istatus'] . ", " . $pdata['pstatus'];
				$totals_price += $s->payment_amount;
			}
		}
		if($status != 2) {
			//clear
			$where = "";
			//where clause
			if(!empty($date_from)) {
				$where .= " AND h.time>='" . strtotime($date_from) . "'";
			}
			if(!empty($date_to)) {
				$where .= " AND h.time<='" . strtotime($date_to) . "'";
			}
			if(!empty($currency)) {
				$where .= " AND h.currency='" . $currency . "'";
			}
			//process sql
			$sql = $oiopub_db->GetAll("SELECT p.*, h.* FROM " . $oiopub_set->dbtable_purchases_history . " h, " . $oiopub_set->dbtable_purchases . " p WHERE h.item=p.item_id " . $where . " ORDER BY h.time");
			if(!empty($sql)) {
				foreach($sql as $s) {
					$pdata = oiopub_adtype_info($s);
					$date = date("Y-m-d", $s->time);
					if($s->subscription == 1) {
						$subscription = "Yes";
					} else {
						$subscription = "No";
					}
					$array[$s->time] = $s->adv_name . "\t" . ($this->show_emails == 1 ? $s->adv_email : "*****") . "\t" . $pdata['type'] . "\t" . $date . "\t" . $s->amount . "\t" . strtoupper($s->currency) . "\t" . strtolower($s->processor) . "\t" . $subscription . "\tExpired, Paid";
					$totals_price += $s->amount;
				}
			}
		}
		if(!empty($array)) {
			//sort array
			ksort($array);
			$output .= implode("\n", $array) . "\n";
			$output .= "Totals:\t-\t-\t-\t" . $totals_price . "\t-\t-\t-\t-";
		}
		//headers
		header("Content-Disposition: attachment; filename=\"$filename\"");
		header("Content-Type: application/vnd.ms-excel");
		//display
		return $output;
	}
	
	//export affiliate data (excel)
	function excel_affiliates($args=array()) {
		global $oiopub_set, $oiopub_db;
		//clear
		$output = '';
		$array = array();
		//filename
		$filename = "oiopub-affiliates-" . date('Ymd') . ".xls";
		//get args
		$maturity_time = time() - ($oiopub_set->affiliates['maturity'] * 86400);
		//process
		$data = $oiopub_db->GetAll("SELECT s.affiliate_id, SUM(s.affiliate_amount) as total, s.affiliate_currency, a.paypal FROM " . $oiopub_set->dbtable_affiliates_sales . " s LEFT JOIN " . $oiopub_set->dbtable_affiliates . " a ON s.affiliate_id=a.id WHERE s.affiliate_paid='0' AND s.purchase_payment='1' AND s.purchase_time < '$maturity_time' GROUP BY s.affiliate_id, s.affiliate_currency");
		if(!empty($data)) {
			foreach($data as $d) {
				if(!empty($d->paypal) && $d->total > '0.00') {
					$array[] = $d->paypal . "\t" . number_format($d->total, 2) . "\t" . $d->affiliate_currency . "\n";
				}
			}
			$output .= implode("\n", $array) . "\n";
		}
		//headers
		header("Content-Disposition: attachment; filename=\"$filename\"");
		header("Content-Type: application/vnd.ms-excel");
		//display
		return $output;
	}

}

?>