<?php

/*
Copyright (C) 2008  Simon Emery

This file is part of OIOpublisher Direct.
*/

if(!defined('oiopub')) die();

/* ACTIVATION FUNCTIONS */

//deactivate script
function oiopub_script_deactivate() {
	//get vars
	$time = time() - 42000;
	$session_name = session_name();
	//unset session data
	$_SESSION = array();
	//unset session cookie
	if(isset($_COOKIE[$session_name])) {
		setcookie($session_name, '', $time, '/');
	}
	//destroy session
	session_destroy();
	//redirect user
	header("Location: install.php");
	exit();
}

/* AUTH FUNCTIONS */

//auth check
function oiopub_auth_check() {
	global $oiopub_set;
	oiopub_session_start();
	if(!isset($oiopub_set->hash)) {
		return false;
	}
	if(isset($_SESSION['oiopub']['id']) && $_SESSION['oiopub']['id'] > 0) {
		$key = $oiopub_set->hash . strip_tags($_SERVER['HTTP_USER_AGENT']);
		$sess = md5($key . session_id());
		if($sess === $_SESSION['oiopub']['rand']) {
			return true;
		}
	}
	return false;
}

//is admin
function oiopub_is_admin() {
	if(defined('OIOPUB_ADMIN')) {
		return true;
	}
	return false;
}

/* MISC FUNCTIONS */

//admin home url
function oiopub_admin_home_url() {
	global $oiopub_set;
	return $oiopub_set->admin_url . "/admin.php";
}

?>