<?php

/*
Copyright (C) 2008  Simon Emery

This file is part of OIOpublisher Direct.
*/

if(!defined('oiopub')) die();

/* WORDPRESS ADMIN CLASS */

class oiopub_admin_wp extends oiopub_admin {

	var $role = "manage_options";

	//init
	function oiopub_admin_wp() {
		global $oiopub_set;
		$this->init();
		$this->actions();
		//demo mode?
		if($oiopub_set->demo) {
			$this->role = "read";
		}
	}
	
	//actions
	function actions() {
		global $oiopub_alerts;
		add_action('admin_menu', array(&$this, 'menu'));
		add_action('admin_footer', array(&$oiopub_alerts, 'display'));
		add_action('wp_dashboard_setup', array(&$this, 'dashboard_widget'));
	}
	
	//dashboard widget
	function dashboard_widget() {
		if(function_exists('wp_add_dashboard_widget') && oiopub_auth_check()) {
			wp_add_dashboard_widget('oiopublisher_alerts', 'OIOpublisher Alerts', array(&$this, 'dashboard_widget_output'));	
		}
	}
	
	//dashboard widget output
	function dashboard_widget_output() {
		global $oiopub_alerts;
		$oiopub_alerts->purchases(-1);
	}
	
	//admin menu
	function menu() {
		global $oiopub_set;
		//base file
		$file = $oiopub_set->folder_dir."/wp.php";
		//get help url
		if(isset($_GET['page']) && strpos($_GET['page'], "oiopub-") === 0) {
			$help = explode("page=", $oiopub_set->request_uri);
			$help = $help[1] . "&help=1";
		} else {
			$help = $file . "&help=1";
		}
		//add pages
		add_menu_page('OIOpublisher', 'OIOpublisher', $this->role, $file, array(&$this, 'overview'));
		add_submenu_page($file, 'Settings', 'Settings', $this->role, 'oiopub-settings.php', array(&$this, 'settings'));
		add_submenu_page($file, 'Purchases', 'Purchases', $this->role, 'oiopub-manager.php', array(&$this, 'purchases'));
		add_submenu_page($file, 'Modules', 'Modules', $this->role, 'oiopub-modules.php', array(&$this, 'modules'));
		add_submenu_page($file, 'Ad Server', 'Ad Server', $this->role, 'oiopub-adserver.php', array(&$this, 'adserver'));
		add_submenu_page($file, 'API Key', 'API Key', $this->role, 'oiopub-api.php', array(&$this, 'api'));
		add_submenu_page($file, 'Get Help', 'Get Help', $this->role, $help, array(&$this, 'help'));
	}
	
	//get role
	function get_role() {
		return $this->role;
	}

}

?>