<?php

/*
Copyright (C) 2008  Simon Emery

This file is part of OIOpublisher Direct.
*/

if(!defined('oiopub')) die();

/* WORDPRESS WIDGETS CLASS */

class oiopub_widgets {

	//init
	function oiopub_widgets() {
    //add widgets
    $this->widgets();
	}

	//widgets
	function widgets() {
		//function exists?
		if(!function_exists('register_sidebar_widget')) {
			return;
		}
		//core widgets
		register_sidebar_widget('OIOpub Ad Badge', array(&$this, 'ad_badge'));
		register_widget_control('OIOpub Ad Badge', array(&$this, 'ad_badge_edit'));
		register_sidebar_widget('OIOpub Ad Slots', array(&$this, 'ad_slots'));
		register_widget_control('OIOpub Ad Slots', array(&$this, 'ad_slots_edit'));
		//text ad widget
		if(oiopub_links) {
			register_sidebar_widget('OIOpub Link Zone', array(&$this, 'link_zone'));
			register_widget_control('OIOpub Link Zone', array(&$this, 'link_zone_edit'));
		}
		//banner ad widget
		if(oiopub_banners) {
			register_sidebar_widget('OIOpub Banner Zone', array(&$this, 'banner_zone'));
			register_widget_control('OIOpub Banner Zone', array(&$this, 'banner_zone_edit'));
		}
	}
	
	//ad badge
	function ad_badge($args) {
		if(function_exists('oiopub_ad_badge')) {
			extract($args);
			$options = get_option('widget_oiopub1');
			$res = oiopub_ad_badge($options['image'], $options['width'], $options['height']);
			if(!empty($res)) {
				echo $before_widget . "\n";
				echo $res . "\n";
				echo $after_widget . "\n";
			}
		}
	}
	
	//ad badge edit
	function ad_badge_edit() {
		$options = get_option('widget_oiopub1');
		if(isset($_POST['oiopub_ad_badge']) && $_POST['oiopub_ad_badge'] == "yes1") {
			$options['image'] = oiopub_clean($_POST['oiopub_ad_badge_image']);
			$options['width'] = intval($_POST['oiopub_ad_badge_width']);
			$options['height'] = intval($_POST['oiopub_ad_badge_height']);
			update_option('widget_oiopub1', $options);
		}
		echo '<input type="hidden" name="oiopub_ad_badge" value="yes1" />';
		echo '<table width="100%" border="0">';
		echo '<tr><td>Image URL:</td><td><input type="text" name="oiopub_ad_badge_image" value="' . $options['image'] . '" /></td></tr>';
		echo '<tr><td>Width:</td><td><input type="text" name="oiopub_ad_badge_width" value="' . $options['width'] . '" /></td></tr>';
		echo '<tr><td>Height:</td><td><input type="text" name="oiopub_ad_badge_height" value="' . $options['height'] . '" /></td></tr>';
		echo '<tr><td></td><td><input type="submit" value="Update Settings" /></td></tr>';
		echo '</table>';	
	}
	
	//ad slots
	function ad_slots($args) {
		if(function_exists('oiopub_ad_slots')) {
			extract($args);
			$options = get_option('widget_oiopub3');
			if(!empty($options['title'])) {
				$title = $before_title . $options['title'] . $after_title;
			} else {
				$title = "";
			}
			$res = oiopub_ad_slots($title);
			if(!empty($res)) {
				echo $before_widget . "\n";
				echo $res . "\n";
				echo $after_widget . "\n";
			}
		}
	}

	//ad slots edit
	function ad_slots_edit() {
		$options = get_option('widget_oiopub3');
		if(isset($_POST['oiopub_ad_slots']) && $_POST['oiopub_ad_slots'] == "yes3") {
			$options['title'] = strip_tags($_POST['oiopub_ad_slots_title']);
			update_option('widget_oiopub3', $options);
		}
		echo '<input type="hidden" name="oiopub_ad_slots" value="yes3" />';
		echo '<table width="100%" border="0">';
		echo '<tr><td>Title:</td><td><input type="text" name="oiopub_ad_slots_title" value="' . stripslashes($options['title']) . '" /></td></tr>';
		echo '<tr><td></td><td><input type="submit" value="Update Settings" /></td></tr>';
		echo '</table>';
	}
	
	//link zone
	function link_zone($args) {
		if(function_exists('oiopub_link_zone')) {
			extract($args);
			$options = get_option('widget_oiopub2');
			$zone = (empty($options['zone']) ? 1 : $options['zone']);
			$position = (empty($options['position']) ? "center" : $options['position']);
			if(!empty($options['title'])) {
				$title = $before_title . $options['title'] . $after_title;
			} else {
				$title = "";
			}
			$res = oiopub_link_zone($zone, $position, $title, 1);
			if(!empty($res)) {
				echo $before_widget . "\n";
				echo $res . "\n";
				echo $after_widget . "\n";
			}
		}
	}
	
	//link zone edit
	function link_zone_edit() {
		$options = get_option('widget_oiopub2');
		if(isset($_POST['oiopub_link_zone']) && $_POST['oiopub_link_zone'] == "yes2") {
			$options['zone'] = intval($_POST['oiopub_link_zone_zone']);
			$options['title'] = strip_tags($_POST['oiopub_link_zone_title']);
			$options['position'] = oiopub_clean($_POST['oiopub_link_zone_position']);
			update_option('widget_oiopub2', $options);
		}
		$options['zone'] = (empty($options['zone']) ? 1 : $options['zone']);
		$options['position'] = (empty($options['position']) ? "center" : $options['position']);
		$pos_array = array( "left", "center", "right" );
		echo '<input type="hidden" name="oiopub_link_zone" value="yes2" />';
		echo '<table width="100%" border="0">';
		echo '<tr><td>Zone ID:</td><td><input type="text" name="oiopub_link_zone_zone" value="' . $options['zone'] . '" /></td></tr>';
		echo '<tr><td>Title:</td><td><input type="text" name="oiopub_link_zone_title" value="' . stripslashes($options['title']) . '" /></td></tr>';
		echo '<tr><td>Position:</td><td>' . oiopub_dropmenu_k($pos_array, "oiopub_link_zone_position", $options['position']) . '</td></tr>';
		echo '<tr><td></td><td><input type="submit" value="Update Settings" /></td></tr>';
		echo '</table>';
		echo '<small>To add more ad zones using widgets, please install <a href="http://wordpress.org/extend/plugins/php-code-widget/" target="_blank">this plugin</a>, which lets you use the OIOpub link <a href="admin.php?page=oiopub-settings.php&opt=link" target="_blank">output code</a> in widgets easily (php version).</small>';
	}
	
	//banner zone
	function banner_zone($args) {
		if(function_exists('oiopub_banner_zone')) {
			extract($args);
			$options = get_option('widget_oiopub4');
			$zone = (empty($options['zone']) ? 1 : $options['zone']);
			$position = (empty($options['position']) ? "center" : $options['position']);
			if(!empty($options['title'])) {
				$title = $before_title . $options['title'] . $after_title;
			} else {
				$title = "";
			}
			$res = oiopub_banner_zone($zone, $position, $title, 1);
			if(!empty($res)) {
				echo $before_widget . "\n";
				echo $res . "\n";
				echo $after_widget . "\n";
			}
		}
	}
	
	//banner zone edit
	function banner_zone_edit() {
		$options = get_option('widget_oiopub4');
		if(isset($_POST['oiopub_banner_zone']) && $_POST['oiopub_banner_zone'] == "yes4") {
			$options['zone'] = intval($_POST['oiopub_banner_zone_zone']);
			$options['title'] = strip_tags($_POST['oiopub_banner_zone_title']);
			$options['position'] = oiopub_clean($_POST['oiopub_banner_zone_position']);
			update_option('widget_oiopub4', $options);
		}
		$options['zone'] = (empty($options['zone']) ? 1 : $options['zone']);
		$options['position'] = (empty($options['position']) ? "center" : $options['position']);
		$pos_array = array( "left", "center", "right" );
		echo '<input type="hidden" name="oiopub_banner_zone" value="yes4" />';
		echo '<table width="100%" border="0">';
		echo '<tr><td>Zone ID:</td><td><input type="text" name="oiopub_banner_zone_zone" value="' . $options['zone'] . '" /></td></tr>';
		echo '<tr><td>Title:</td><td><input type="text" name="oiopub_banner_zone_title" value="' . stripslashes($options['title']) . '" /></td></tr>';
		echo '<tr><td>Position:</td><td>' . oiopub_dropmenu_k($pos_array, "oiopub_banner_zone_position", $options['position']) . '</td></tr>';
		echo '<tr><td></td><td><input type="submit" value="Update Settings" /></td></tr>';
		echo '</table>';
		echo '<small>To add more ad zones using widgets, please install <a href="http://wordpress.org/extend/plugins/php-code-widget/" target="_blank">this plugin</a>, which lets you use the OIOpub banner <a href="admin.php?page=oiopub-settings.php&opt=banner" target="_blank">output code</a> in widgets easily (php version).</small>';
	}

}

?>